@echo off
goto intro

rem --------------------------------------------------------------------------

rem Requirememts:

rem   - Windows 95 or later
rem         * Visual Basic 6.0 Runtime existence is displayed.
rem         * Target Directory is opened. ( Internet Explorer 4.0 or later )

rem   - If Windows Script Host 2.0 (also termed WSH 5.1) or later is installed,
rem         * Runtime version and Registry status are displayed. (and 7-Zip)


rem Resources:

rem   - MSVBVM60.DLL [Install]:
rem         https://www.microsoft.com/en-us/download/details.aspx?id=24417

rem   - COMDLG32.OCX and MSCOMCTL.OCX [Extract - Regsvr32]:
rem         https://www.microsoft.com/en-us/download/details.aspx?id=50722

rem   - DX7VB.DLL and DX8VB.DLL [Extract - Regsvr32]:
rem         https://web.archive.org/web/20161011001749/https://www.microsoft.com/ja-JP/download/details.aspx?id=10968

rem   - MSVCR100.DLL [Install]:
rem         https://www.microsoft.com/ja-jp/download/details.aspx?id=26999

rem   - VB6JP.DLL [Extract]:
rem         https://www.nothing.sh/download/

rem   - 7-Zip [Install]:
rem         https://www.7-zip.org/


rem OSVER.BAT: https://hitkey.nekokan.dyndns.info/diary2001.php#D200221
rem   * 2024-01-06: v0.0.4 (Windows 11)
rem   * 2020-03-15: v0.0.3 (quoted path string)
rem   * 2020-03-03: v0.0.2 (7-Zip, improved NT 4.0, Win10 ReleaseId, reduced size)
rem   * 2020-02-21: v0.0.1


rem --------------------------------------------------------------------------



:intro
    ver|find "DOS">NUL
    if not errorlevel 1 goto dos

    ver|find "Windows 95">NUL
    if not errorlevel 1 goto win9x

    ver|find "Windows 98">NUL
    if not errorlevel 1 goto win9x

    ver|find "Windows Millennium">NUL
    if not errorlevel 1 goto win9x

    ver|find "NT">NUL
    if not errorlevel 1 goto winnt2x

    ver|find "2000">NUL
    if not errorlevel 1 goto winnt2x

    ver|find "XP">NUL
    if not errorlevel 1 goto winxpx

    ver|find "2003">NUL
    if not errorlevel 1 goto winxpx

    if not exist "%SystemRoot%\system32\systeminfo.exe" goto warn

rem --------------------------------------------------------------------------


    cscript|find "Version">NUL
    if not errorlevel 1 goto js




    setlocal enableextensions
    for /f "tokens=2,3 delims=," %%a in (
        '%SystemRoot%\system32\systeminfo.exe /FO CSV /NH'
    ) do (
        set OSVERS=%%a
        set OSSUBS=%%b
    )

    set OSSYST=%SystemRoot%\SysWOW64
    if "%PROCESSOR_ARCHITECTURE%" equ "x86" (
        if "%PROCESSOR_ARCHITEW6432%" equ "AMD64" (
            set OSBITS=64-bit
        ) else if "%PROCESSOR_ARCHITEW6432%" equ "IA64" (
            set OSBITS=64-bit
        ) else if "%PROCESSOR_ARCHITEW6432%" equ "ARM64" (
            set OSBITS=64-bit
        ) else if "%PROCESSOR_ARCHITEW6432%" equ "EM64T" (
            set OSBITS=64-bit
        ) else (
            set OSBITS=32-bit
            set OSSYST=%SystemRoot%\System32
        )
    ) else (
        set OSBITS=64-bit
    )

    echo Operating System: %OSVERS:~1,-1%
    echo OS Minor Version: %OSSUBS:~1,-1%
    echo OS Bit Width    : %OSBITS%
    echo Target Directory: %OSSYST%

    ver|find " 6.0.">NUL
    if not errorlevel 1 goto winvista

    ver|find " 6.1.">NUL
    if not errorlevel 1 goto win7

    ver|find " 6.2.">NUL
    if not errorlevel 1 goto win8

    ver|find " 6.3.">NUL
    if not errorlevel 1 goto win81

    ver|find " 10.0.">NUL
    if not errorlevel 1 goto win10


    endlocal
    goto warn

:dos
    echo Operating System: DOS // not supported
    goto eof


rem --------------------------------------------------------------------------


:win9x
    if not exist "%windir%\SYSTEM\WSHOM.OCX" goto win9xA

    cscript|find "Version">NUL
    if not errorlevel 1 goto win9xC
    goto win9xA

:win9xC
    cscript|find "Version 5.0">NUL
    if not errorlevel 1 goto win9xA







:js
    rem ----------------------------------------------------------------------

    if exist "%Temp%\z.js" del "%Temp%\z.js"
    copy nul "%Temp%\z.js">NUL

echo /*global WScript, Enumerator, GetObject */>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo var ms_us = "https://www.microsoft.com/en-us/download/details.aspx?id=";>>"%Temp%\z.js"
echo var ms_ja = "https://www.microsoft.com/ja-jp/download/details.aspx?id=";>>"%Temp%\z.js"
echo var ms_old = "http://www.microsoft.com/downloads/details.aspx";>>"%Temp%\z.js"
echo var wao = "https://web.archive.org/web/";>>"%Temp%\z.js"
echo var dlj = "\u0026DisplayLang=ja";>>"%Temp%\z.js"
echo var dx = "[DirectX ";>>"%Temp%\z.js"
echo var rfw = " Runtime for Windows ";>>"%Temp%\z.js"
echo var id1 = "-A3C9-08002B2F49FB";>>"%Temp%\z.js"
echo var id2 = "-8596-11D1-B16A-00C0F0283628";>>"%Temp%\z.js"
echo var id3 = "[Microsoft Visual Basic 6.0 Service Pack 6 Security Rollup Update]";>>"%Temp%\z.js"
echo var specs = {>>"%Temp%\z.js"
echo     "MSVBVM60.DLL": {>>"%Temp%\z.js"
echo         "95!,98!,ME!,NT!,2000!,XP!": {>>"%Temp%\z.js"
echo             min_file_version: "6.0.97.82",>>"%Temp%\z.js"
echo             min_product_version: "6.00.9782",>>"%Temp%\z.js"
echo             from: "[Service Pack 6 for Visual Basic 6.0: ">>"%Temp%\z.js"
echo                 + "Run-Time Redistribution Pack (vbrun60sp6.exe)]",>>"%Temp%\z.js"
echo             url: ms_us + "24417">>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         guid: [>>"%Temp%\z.js"
echo             "D5DE8D20-5BB8-11D1-A1E3-00A0C90F2731">>"%Temp%\z.js"
echo         ],>>"%Temp%\z.js"
echo         target: [>>"%Temp%\z.js"
echo             "BMSE",>>"%Temp%\z.js"
echo             "uBMplay">>"%Temp%\z.js"
echo         ]>>"%Temp%\z.js"
echo     },>>"%Temp%\z.js"
echo     "COMDLG32.OCX": {>>"%Temp%\z.js"
echo         "95!,98!,ME!,NT!,2000!,XP!": {>>"%Temp%\z.js"
echo             min_file_version: "6.1.98.41",>>"%Temp%\z.js"
echo             min_product_version: "6.01.9841",>>"%Temp%\z.js"
echo             from: id3,>>"%Temp%\z.js"
echo             url: ms_us + "50722">>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         guid: [>>"%Temp%\z.js"
echo             "3C4F3BE3-47EB-101B" + id1,>>"%Temp%\z.js"
echo             "3C4F3BE5-47EB-101B" + id1,>>"%Temp%\z.js"
echo             "3C4F3BE7-47EB-101B" + id1,>>"%Temp%\z.js"
echo             "7629CFA2-3FE5-101B" + id1,>>"%Temp%\z.js"
echo             "7629CFA4-3FE5-101B" + id1,>>"%Temp%\z.js"
echo             "8F0F480A-4366-4737-8265-2AD6FDAC8C31",>>"%Temp%\z.js"
echo             "F9043C85-F6F2-101A" + id1>>"%Temp%\z.js"
echo         ],>>"%Temp%\z.js"
echo         target: [>>"%Temp%\z.js"
echo             "BMSE",>>"%Temp%\z.js"
echo             "uBMplay">>"%Temp%\z.js"
echo         ]>>"%Temp%\z.js"
echo     },>>"%Temp%\z.js"
echo     "MSCOMCTL.OCX": {>>"%Temp%\z.js"
echo         "95!,98!,ME!,NT!,2000!,XP!": {>>"%Temp%\z.js"
echo             min_file_version: "6.1.98.46",>>"%Temp%\z.js"
echo             min_product_version: "6.01.9846",>>"%Temp%\z.js"
echo             from: id3,>>"%Temp%\z.js"
echo             url: ms_us + "50722">>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         guid: [>>"%Temp%\z.js"
echo             "0B314611-2C19-4AB4-8513-A6EEA569D3C4",>>"%Temp%\z.js"
echo             "1EFB6596-857C-11D1-B16A-00C0F0283628",>>"%Temp%\z.js"
echo             "24B224E0-9545-4A2F-ABD5-86AA8A849385",>>"%Temp%\z.js"
echo             "2C247F23-8591-11D1-B16A-00C0F0283628",>>"%Temp%\z.js"
echo             "35053A22-8589-11D1-B16A-00C0F0283628",>>"%Temp%\z.js"
echo             "556C2772-F1AD-4DE1-8456-BD6E8F66113B",>>"%Temp%\z.js"
echo             "585AA280-ED8B-46B2-93AE-132ECFA1DAFC",>>"%Temp%\z.js"
echo             "627C8B79-918A-4C5C-9E19-20F66BF30B86",>>"%Temp%\z.js"
echo             "66833FE6-8583-11D1-B16A-00C0F0283628",>>"%Temp%\z.js"
echo             "7DC6F291-BF55-4E50-B619-EF672D9DCC58",>>"%Temp%\z.js"
echo             "87DACC48-F1C5-4AF3-84BA-A2A72C2AB959",>>"%Temp%\z.js"
echo             "8B2ADD10-33B7-4506-9569-0A1E1DBBEBAE",>>"%Temp%\z.js"
echo             "8E3867A3-8586-11D1-B16A-00C0F0283628",>>"%Temp%\z.js"
echo             "9181DC5F-E07D-418A-ACA6-8EEA1ECB8E9E",>>"%Temp%\z.js"
echo             "95F0B3BE-E8AC-4995-9DCA-419849E06410",>>"%Temp%\z.js"
echo             "979127D3-7D01-4FDE-AF65-A698091468AF",>>"%Temp%\z.js"
echo             "996BF5E0-8044-4650-ADEB-0B013914E99C",>>"%Temp%\z.js"
echo             "9A948063-66C3-4F63-AB46-582EDAA35047",>>"%Temp%\z.js"
echo             "A0E7BF67-8D30-4620-8825-7111714C7CAB",>>"%Temp%\z.js"
echo             "BDD1F04B-858B-11D1-B16A-00C0F0283628",>>"%Temp%\z.js"
echo             "C27CCE32" + id2,>>"%Temp%\z.js"
echo             "C27CCE33" + id2,>>"%Temp%\z.js"
echo             "C27CCE34" + id2,>>"%Temp%\z.js"
echo             "C27CCE35" + id2,>>"%Temp%\z.js"
echo             "C27CCE36" + id2,>>"%Temp%\z.js"
echo             "C27CCE37" + id2,>>"%Temp%\z.js"
echo             "C27CCE38" + id2,>>"%Temp%\z.js"
echo             "C27CCE39" + id2,>>"%Temp%\z.js"
echo             "C27CCE3A" + id2,>>"%Temp%\z.js"
echo             "C27CCE3B" + id2,>>"%Temp%\z.js"
echo             "C27CCE3C" + id2,>>"%Temp%\z.js"
echo             "C27CCE3D" + id2,>>"%Temp%\z.js"
echo             "C27CCE3E" + id2,>>"%Temp%\z.js"
echo             "C27CCE3F" + id2,>>"%Temp%\z.js"
echo             "C27CCE40" + id2,>>"%Temp%\z.js"
echo             "C27CCE41" + id2,>>"%Temp%\z.js"
echo             "C27CCE42" + id2,>>"%Temp%\z.js"
echo             "C74190B6-8589-11D1-B16A-00C0F0283628",>>"%Temp%\z.js"
echo             "CCDB0DF2-FD1A-4856-80BC-32929D8359B7",>>"%Temp%\z.js"
echo             "DD2DBE12-F9F8-4E32-B087-DAD1DCEF0783",>>"%Temp%\z.js"
echo             "DD9DA666-8594-11D1-B16A-00C0F0283628",>>"%Temp%\z.js"
echo             "F08DF954-8592-11D1-B16A-00C0F0283628",>>"%Temp%\z.js"
echo             "F91CAF91-225B-43A7-BB9E-472F991FC402">>"%Temp%\z.js"
echo         ],>>"%Temp%\z.js"
echo         target: [>>"%Temp%\z.js"
echo             "BMSE">>"%Temp%\z.js"
echo         ]>>"%Temp%\z.js"
echo     },>>"%Temp%\z.js"
echo     "DX7VB.DLL": {>>"%Temp%\z.js"
echo         "95!": {>>"%Temp%\z.js"
echo             min_file_version: "4.8.0.400",>>"%Temp%\z.js"
echo             min_product_version: "4.08.00.0400",>>"%Temp%\z.js"
echo             from: dx + "8.0a" + rfw + "95/98/ME]",>>"%Temp%\z.js"
echo             url: wao + "20101218142453/" + ms_old>>"%Temp%\z.js"
echo                 + "?FamilyID=c55c9e71-94cb-4f70-80cc-d09e5acd075b" + dlj>>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         "98!,ME!": {>>"%Temp%\z.js"
echo             min_file_version: "4.8.1.881",>>"%Temp%\z.js"
echo             min_product_version: "4.08.01.0881",>>"%Temp%\z.js"
echo             from: dx + "8.1b" + rfw + "98/ME]",>>"%Temp%\z.js"
echo             url: wao + "20040527082221/" + ms_old>>"%Temp%\z.js"
echo                 + "?FamilyID=63dafd1a-f9c9-4f35-89b0-261abc0e37a9" + dlj>>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         "2000!,XP!": {>>"%Temp%\z.js"
echo             min_file_version: "5.1.2600.881",>>"%Temp%\z.js"
echo             min_product_version: "5.1.2600.881",>>"%Temp%\z.js"
echo             from: dx + "8.1" + rfw + "2000]",>>"%Temp%\z.js"
echo             url: wao + "20161011001749/" + ms_ja + "10968">>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         guid: [>>"%Temp%\z.js"
echo             "E1211353-8E94-11D1-8808-00C04FC2C602">>"%Temp%\z.js"
echo         ],>>"%Temp%\z.js"
echo         target: [>>"%Temp%\z.js"
echo             "nazobmplay",>>"%Temp%\z.js"
echo             "uBMplay">>"%Temp%\z.js"
echo         ]>>"%Temp%\z.js"
echo     },>>"%Temp%\z.js"
echo     "DX8VB.DLL": {>>"%Temp%\z.js"
echo         "95!": {>>"%Temp%\z.js"
echo             min_file_version: "4.8.0.400",>>"%Temp%\z.js"
echo             min_product_version: "4.08.00.0400",>>"%Temp%\z.js"
echo             from: dx + "8.0a" + rfw + "95/98/ME]",>>"%Temp%\z.js"
echo             url: wao + "20101218142453/" + ms_old>>"%Temp%\z.js"
echo                 + "?FamilyID=c55c9e71-94cb-4f70-80cc-d09e5acd075b" + dlj>>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         "98!,ME!": {>>"%Temp%\z.js"
echo             min_file_version: "4.8.1.881",>>"%Temp%\z.js"
echo             min_product_version: "4.08.01.0881",>>"%Temp%\z.js"
echo             from: dx + "8.1b" + rfw + "98/ME]",>>"%Temp%\z.js"
echo             url: wao + "20040527082221/" + ms_old>>"%Temp%\z.js"
echo                 + "?FamilyID=63dafd1a-f9c9-4f35-89b0-261abc0e37a9" + dlj>>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         "2000!,XP!": {>>"%Temp%\z.js"
echo             min_file_version: "5.1.2600.881",>>"%Temp%\z.js"
echo             min_product_version: "5.1.2600.881",>>"%Temp%\z.js"
echo             from: dx + "8.1" + rfw + "2000]",>>"%Temp%\z.js"
echo             url: wao + "20161011001749/" + ms_ja + "10968">>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         guid: [>>"%Temp%\z.js"
echo             "58356C5D-0BFD-48ED-93C5-F4520B6233DE",>>"%Temp%\z.js"
echo             "E7FF1300-96A5-11D3-AC85-00C04FC2C602">>"%Temp%\z.js"
echo         ],>>"%Temp%\z.js"
echo         target: [>>"%Temp%\z.js"
echo             "nazobmplay">>"%Temp%\z.js"
echo         ]>>"%Temp%\z.js"
echo     },>>"%Temp%\z.js"
echo     "MSVCR100.DLL": {>>"%Temp%\z.js"
echo         "XP!": {>>"%Temp%\z.js"
echo             min_file_version: "10.0.40219.325",>>"%Temp%\z.js"
echo             min_product_version: "10.00.40219.325",>>"%Temp%\z.js"
echo             from: "[Microsoft Visual C++ 2010 Service Pack 1 ">>"%Temp%\z.js"
echo                 + "Redistributable Package MFC Security Update (x86)]",>>"%Temp%\z.js"
echo             url: ms_ja + "26999">>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         guid: [],>>"%Temp%\z.js"
echo         target: [>>"%Temp%\z.js"
echo             "uBMplay 1.5.x">>"%Temp%\z.js"
echo         ]>>"%Temp%\z.js"
echo     },>>"%Temp%\z.js"
echo     "VB6JP.DLL": {>>"%Temp%\z.js"
echo         "95!,98!,ME!,NT!,2000!,XP!": {>>"%Temp%\z.js"
echo             min_file_version: "6.0.89.88",>>"%Temp%\z.js"
echo             min_product_version: "6.0.8988",>>"%Temp%\z.js"
echo             from: "[vb6jp.cab (on area[nothing] /download)]",>>"%Temp%\z.js"
echo             url: "https://www.nothing.sh/download/">>"%Temp%\z.js"
echo         },>>"%Temp%\z.js"
echo         guid: [],>>"%Temp%\z.js"
echo         target: [>>"%Temp%\z.js"
echo             "nazobmplay",>>"%Temp%\z.js"
echo             "nBMplay",>>"%Temp%\z.js"
echo             "WAview">>"%Temp%\z.js"
echo         ]>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo };>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function err (m) {>>"%Temp%\z.js"
echo     try {>>"%Temp%\z.js"
echo         throw {>>"%Temp%\z.js"
echo             name: "SyntaxError",>>"%Temp%\z.js"
echo             message: m>>"%Temp%\z.js"
echo         };>>"%Temp%\z.js"
echo     } catch (e) {>>"%Temp%\z.js"
echo         WScript.echo(e.name + ":\n" + e.message);>>"%Temp%\z.js"
echo         WScript.quit(1);>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function numerizeChar (c) {>>"%Temp%\z.js"
echo     var t = typeof c;>>"%Temp%\z.js"
echo     if (t === "number") {>>"%Temp%\z.js"
echo         return c;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (t !== "string") {>>"%Temp%\z.js"
echo         err("TypeError: " + t);>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (c.length !== 1) {>>"%Temp%\z.js"
echo         err("Arg.length must be 1: " + c);>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return c.charCodeAt(0);>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function lt (a, b) {>>"%Temp%\z.js"
echo     var x = numerizeChar(a);>>"%Temp%\z.js"
echo     var y = numerizeChar(b);>>"%Temp%\z.js"
echo     if (x === y) {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return x === Math.min(x, y);>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function lte (a, b) {>>"%Temp%\z.js"
echo     var x = numerizeChar(a);>>"%Temp%\z.js"
echo     var y = numerizeChar(b);>>"%Temp%\z.js"
echo     if (x === y) {>>"%Temp%\z.js"
echo         return true;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return x === Math.min(x, y);>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function gt (a, b) {>>"%Temp%\z.js"
echo     var x = numerizeChar(a);>>"%Temp%\z.js"
echo     var y = numerizeChar(b);>>"%Temp%\z.js"
echo     if (x === y) {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return x === Math.max(x, y);>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function gte (a, b) {>>"%Temp%\z.js"
echo     var x = numerizeChar(a);>>"%Temp%\z.js"
echo     var y = numerizeChar(b);>>"%Temp%\z.js"
echo     if (x === y) {>>"%Temp%\z.js"
echo         return true;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return x === Math.max(x, y);>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function isRegExpSpace (c) {>>"%Temp%\z.js"
echo     if (lte(c, 32)) {>>"%Temp%\z.js"
echo         return true;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (gte(c, 8192)) {>>"%Temp%\z.js"
echo         if (lte(c, 8202)) {>>"%Temp%\z.js"
echo             return true;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     switch (c) {>>"%Temp%\z.js"
echo     case 160:>>"%Temp%\z.js"
echo     case 5760:>>"%Temp%\z.js"
echo     case 8232:>>"%Temp%\z.js"
echo     case 8233:>>"%Temp%\z.js"
echo     case 8239:>>"%Temp%\z.js"
echo     case 8287:>>"%Temp%\z.js"
echo     case 12288:>>"%Temp%\z.js"
echo     case 65279:>>"%Temp%\z.js"
echo         return true;>>"%Temp%\z.js"
echo     default:>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function trim (str) {>>"%Temp%\z.js"
echo     if (typeof str !== "string") {>>"%Temp%\z.js"
echo         return "";>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     str = str.toString();>>"%Temp%\z.js"
echo     var begin = 0;>>"%Temp%\z.js"
echo     var end = str.length - 1;>>"%Temp%\z.js"
echo     while (lte(begin, end)) {>>"%Temp%\z.js"
echo         if (!isRegExpSpace(str.charCodeAt(begin))) {>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         begin += 1;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     while (gt(end, begin)) {>>"%Temp%\z.js"
echo         if (!isRegExpSpace(str.charCodeAt(end))) {>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         end -= 1;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return str.slice(begin, end + 1);>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function removeArrayDuplicates (array) {>>"%Temp%\z.js"
echo     var exist = {};>>"%Temp%\z.js"
echo     var result = [];>>"%Temp%\z.js"
echo     var i = 0;>>"%Temp%\z.js"
echo     var l = array.length;>>"%Temp%\z.js"
echo     var tmp;>>"%Temp%\z.js"
echo     while (lt(i, l)) {>>"%Temp%\z.js"
echo         tmp = array[i];>>"%Temp%\z.js"
echo         if (!exist[tmp]) {>>"%Temp%\z.js"
echo             exist[tmp] = true;>>"%Temp%\z.js"
echo             result[result.length] = tmp;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         i += 1;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return result;>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function getVersion (path) {>>"%Temp%\z.js"
echo     var fso = WScript.createObject("Scripting.FileSystemObject");>>"%Temp%\z.js"
echo     var tmp;>>"%Temp%\z.js"
echo     if (!fso.fileExists(path)) {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     tmp = fso.getFileVersion(path);>>"%Temp%\z.js"
echo     if (!tmp) {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return tmp;>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function isNumericChar (c) {>>"%Temp%\z.js"
echo     return (>>"%Temp%\z.js"
echo         gte(c, "0")>>"%Temp%\z.js"
echo         ? lte(c, "9")>>"%Temp%\z.js"
echo         : false>>"%Temp%\z.js"
echo     );>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function isCommaOrFullstop (c) {>>"%Temp%\z.js"
echo     if (c === ",") {>>"%Temp%\z.js"
echo         return true;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (c === ".") {>>"%Temp%\z.js"
echo         return true;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return false;>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function isNotString (str) {>>"%Temp%\z.js"
echo     if (!str) {>>"%Temp%\z.js"
echo         return true;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (typeof str !== "string") {>>"%Temp%\z.js"
echo         return true;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return false;>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function parseVersion (str) {>>"%Temp%\z.js"
echo     if (isNotString(str)) {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     var buffer = [];>>"%Temp%\z.js"
echo     var i = 0;>>"%Temp%\z.js"
echo     var l = str.length;>>"%Temp%\z.js"
echo     var c = "";>>"%Temp%\z.js"
echo     var n = "";>>"%Temp%\z.js"
echo     while (lt(i, l)) {>>"%Temp%\z.js"
echo         c = str.charAt(i);>>"%Temp%\z.js"
echo         if (isNumericChar(c)) {>>"%Temp%\z.js"
echo             n += c;>>"%Temp%\z.js"
echo         } else if (isCommaOrFullstop(c)) {>>"%Temp%\z.js"
echo             buffer[buffer.length] = parseInt(n, 10);>>"%Temp%\z.js"
echo             n = "";>>"%Temp%\z.js"
echo         } else {>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         i += 1;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (n) {>>"%Temp%\z.js"
echo         buffer[buffer.length] = parseInt(n, 10);>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return (>>"%Temp%\z.js"
echo         buffer.length>>"%Temp%\z.js"
echo         ? buffer>>"%Temp%\z.js"
echo         : false>>"%Temp%\z.js"
echo     );>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function isLaterVersion (target, criterion) {>>"%Temp%\z.js"
echo     var v1 = parseVersion(target);>>"%Temp%\z.js"
echo     var v2 = parseVersion(criterion);>>"%Temp%\z.js"
echo     var i = 0;>>"%Temp%\z.js"
echo     var l;>>"%Temp%\z.js"
echo     if (!v1) {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (!v2) {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (lt(v1.length, v2.length)) {>>"%Temp%\z.js"
echo         while (v1.length !== v2.length) {>>"%Temp%\z.js"
echo             v1[v1.length] = 0;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo     } else if (gt(v1.length, v2.length)) {>>"%Temp%\z.js"
echo         while (v1.length !== v2.length) {>>"%Temp%\z.js"
echo             v2[v2.length] = 0;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     l = v1.length;>>"%Temp%\z.js"
echo     while (lt(i, l)) {>>"%Temp%\z.js"
echo         if (gt(v1[i], v2[i])) {>>"%Temp%\z.js"
echo             return true;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         if (lt(v1[i], v2[i])) {>>"%Temp%\z.js"
echo             return false;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         i += 1;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return true;>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function reg_key_exists (reg_key) {>>"%Temp%\z.js"
echo     var ws = WScript.createObject("WScript.Shell");>>"%Temp%\z.js"
echo     try {>>"%Temp%\z.js"
echo         ws.regRead(reg_key);>>"%Temp%\z.js"
echo         return true;>>"%Temp%\z.js"
echo     } catch (e) {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function getEnvironments () {>>"%Temp%\z.js"
echo     var s = WScript.createObject("WScript.Shell");>>"%Temp%\z.js"
echo     var env = s.environment("Process");>>"%Temp%\z.js"
echo     var bitwidth = env.item("PROCESSOR_ARCHITECTURE");>>"%Temp%\z.js"
echo     var branch = (>>"%Temp%\z.js"
echo         env.item("OS").indexOf("Windows_NT") === -1>>"%Temp%\z.js"
echo         ? "Windows">>"%Temp%\z.js"
echo         : "Windows NT">>"%Temp%\z.js"
echo     );>>"%Temp%\z.js"
echo     var pn;>>"%Temp%\z.js"
echo     var target_dir;>>"%Temp%\z.js"
echo     var wd = env.item("WINDIR");>>"%Temp%\z.js"
echo     var type1;>>"%Temp%\z.js"
echo     var curver = "HKLM\\SOFTWARE\\Microsoft\\" + branch + "\\CurrentVersion\\";>>"%Temp%\z.js"
echo     var vernum;>>"%Temp%\z.js"
echo     var ver1;>>"%Temp%\z.js"
echo     var ver2 = curver + "CurrentVersion";>>"%Temp%\z.js"
echo     var sub = "";>>"%Temp%\z.js"
echo     var csd1 = "";>>"%Temp%\z.js"
echo     var wmi;>>"%Temp%\z.js"
echo     var wmiItems;>>"%Temp%\z.js"
echo     var wmie;>>"%Temp%\z.js"
echo     var wmiItem;>>"%Temp%\z.js"
echo     var xpHome;>>"%Temp%\z.js"
echo     var tmp;>>"%Temp%\z.js"
echo     if (bitwidth === "x86") {>>"%Temp%\z.js"
echo         bitwidth = env.item("PROCESSOR_ARCHITEW6432");>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     bitwidth = (>>"%Temp%\z.js"
echo         bitwidth.indexOf("64") !== -1>>"%Temp%\z.js"
echo         ? "64-bit">>"%Temp%\z.js"
echo         : "32-bit">>"%Temp%\z.js"
echo     );>>"%Temp%\z.js"
echo     target_dir = wd + "\\" + (>>"%Temp%\z.js"
echo         branch === "Windows">>"%Temp%\z.js"
echo         ? "SYSTEM">>"%Temp%\z.js"
echo         : (>>"%Temp%\z.js"
echo             bitwidth === "64-bit">>"%Temp%\z.js"
echo             ? "SysWOW64">>"%Temp%\z.js"
echo             : "System32">>"%Temp%\z.js"
echo         )>>"%Temp%\z.js"
echo     );>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo     try {>>"%Temp%\z.js"
echo         pn = s.regRead(curver + "ProductName");>>"%Temp%\z.js"
echo     } catch (e1) {>>"%Temp%\z.js"
echo         tmp = trim(s.regRead(curver + "CurrentBuildNumber"));>>"%Temp%\z.js"
echo         switch (tmp) {>>"%Temp%\z.js"
echo         case "1381":>>"%Temp%\z.js"
echo             pn = "Windows NT 4.0";>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         case "1057":>>"%Temp%\z.js"
echo             pn = "Windows NT 3.51";>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         case "807":>>"%Temp%\z.js"
echo             pn = "Windows NT 3.5";>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         case "528":>>"%Temp%\z.js"
echo             pn = "Windows NT 3.1";>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         default:>>"%Temp%\z.js"
echo             pn = e1.description;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     pn = trim(pn);>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo     if (pn.indexOf("Windows 95") !== -1) {>>"%Temp%\z.js"
echo         type1 = "95!";>>"%Temp%\z.js"
echo     } else if (pn.indexOf("Windows 98") !== -1) {>>"%Temp%\z.js"
echo         type1 = "98!";>>"%Temp%\z.js"
echo     } else if (pn.indexOf("Windows ME") !== -1) {>>"%Temp%\z.js"
echo         type1 = "ME!";>>"%Temp%\z.js"
echo     } else if (branch === "Windows NT") {>>"%Temp%\z.js"
echo         if (pn.indexOf("Windows NT") !== -1) {>>"%Temp%\z.js"
echo             type1 = "NT!";>>"%Temp%\z.js"
echo         } else if (pn.indexOf("Windows 2000") !== -1) {>>"%Temp%\z.js"
echo             type1 = "2000!";>>"%Temp%\z.js"
echo         } else {>>"%Temp%\z.js"
echo             type1 = "XP!";>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo     } else {>>"%Temp%\z.js"
echo         type1 = "?!";>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo     switch (type1) {>>"%Temp%\z.js"
echo     case "XP!":>>"%Temp%\z.js"
echo         ver1 = s.exec("cmd /c ver").StdOut.readAll();>>"%Temp%\z.js"
echo         ver1 = (ver1.split("Version ")[1]) + "!?";>>"%Temp%\z.js"
echo         ver1 = ver1.split("]")[0];>>"%Temp%\z.js"
echo         if (pn.indexOf("XP") !== -1) {>>"%Temp%\z.js"
echo             xpHome = WScript.createObject("Scripting.FileSystemObject")>>"%Temp%\z.js"
echo                 .fileExists(wd + "\\System32\\tasklist.exe");>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         if (isLaterVersion(ver1, "6.4.9840")) { // gte WIN10TP1>>"%Temp%\z.js"
echo             if (isLaterVersion(ver1, "10.0.19999")) { // gte WIN11>>"%Temp%\z.js"
echo                 if (!isLaterVersion(ver1, "10.0.22001")) {>>"%Temp%\z.js"
echo                     sub = "21H2";>>"%Temp%\z.js"
echo                 } else if (!isLaterVersion(ver1, "10.0.22622")) {>>"%Temp%\z.js"
echo                     sub = "22H2";>>"%Temp%\z.js"
echo                 } else if (!isLaterVersion(ver1, "10.0.22632")) {>>"%Temp%\z.js"
echo                     sub = "23H2";>>"%Temp%\z.js"
echo                 } else {>>"%Temp%\z.js"
echo                     sub = "24H1 or greater";>>"%Temp%\z.js"
echo                 }>>"%Temp%\z.js"
echo                 pn = "Windows 11" + pn.slice(10);>>"%Temp%\z.js"
echo             } else { // WIN10>>"%Temp%\z.js"
echo                 if (isLaterVersion(ver1, "10.0.19046")) { // gt 22H2>>"%Temp%\z.js"
echo                     try {>>"%Temp%\z.js"
echo                         ver1 = s.regRead(ver2); // always 6.3>>"%Temp%\z.js"
echo                         sub = s.regRead(curver + "ReleaseId"); // always 2009>>"%Temp%\z.js"
echo                     } catch (e10) {>>"%Temp%\z.js"
echo                         ver1 = e10.description;>>"%Temp%\z.js"
echo                         sub = e10.description;>>"%Temp%\z.js"
echo                     }>>"%Temp%\z.js"
echo                     ver1 = trim(ver1);>>"%Temp%\z.js"
echo                     sub = trim(sub);>>"%Temp%\z.js"
echo                 } else {>>"%Temp%\z.js"
echo if (ver1.indexOf("6.4.9841") === 0) {>>"%Temp%\z.js"
echo     sub = "Technical Preview 1";>>"%Temp%\z.js"
echo } else if (ver1.indexOf("6.4.9860") === 0) {>>"%Temp%\z.js"
echo     sub = "Technical Preview 2";>>"%Temp%\z.js"
echo } else if (ver1.indexOf("6.4.9879") === 0) {>>"%Temp%\z.js"
echo     sub = "Technical Preview 3";>>"%Temp%\z.js"
echo } else if (ver1.indexOf("10.0.9926") === 0) {>>"%Temp%\z.js"
echo     sub = "Technical Preview 4";>>"%Temp%\z.js"
echo } else if (ver1.indexOf("10.0.10041") === 0) {>>"%Temp%\z.js"
echo     sub = "Technical Preview 5";>>"%Temp%\z.js"
echo } else if (ver1.indexOf("10.0.10049") === 0) {>>"%Temp%\z.js"
echo     sub = "Technical Preview 6";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.10241")) {>>"%Temp%\z.js"
echo     sub = "Threshold 1 (Version 1507)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.10587")) {>>"%Temp%\z.js"
echo     sub = "Threshold 2 (Version 1511)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.14394")) {>>"%Temp%\z.js"
echo     sub = "Redstone 1 (Version 1607)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.15064")) {>>"%Temp%\z.js"
echo     sub = "Redstone 2 (Version 1703)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.16300")) {>>"%Temp%\z.js"
echo     sub = "Redstone 3 (Version 1709)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.17135")) {>>"%Temp%\z.js"
echo     sub = "Redstone 4 (Version 1803)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.17764")) {>>"%Temp%\z.js"
echo     sub = "Redstone 5 (Version 1809)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.18363")) {>>"%Temp%\z.js"
echo     sub = "19H1 (Version 1903)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.18364")) {>>"%Temp%\z.js"
echo     sub = "19H2 (Version 1909)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.19042")) {>>"%Temp%\z.js"
echo     sub = "20H1 (Version 2004)";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.19043")) {>>"%Temp%\z.js"
echo     sub = "20H2";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.19044")) {>>"%Temp%\z.js"
echo     sub = "21H1";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.19045")) {>>"%Temp%\z.js"
echo     sub = "21H2";>>"%Temp%\z.js"
echo } else if (!isLaterVersion(ver1, "10.0.19046")) {>>"%Temp%\z.js"
echo     sub = "22H2";>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo                 }>>"%Temp%\z.js"
echo             }>>"%Temp%\z.js"
echo             csd1 = sub;>>"%Temp%\z.js"
echo         } else {>>"%Temp%\z.js"
echo             if (xpHome) {>>"%Temp%\z.js"
echo                 try {>>"%Temp%\z.js"
echo                     ver1 = s.regRead(ver2);>>"%Temp%\z.js"
echo                     sub = s.regRead(curver + "CSDVersion");>>"%Temp%\z.js"
echo                 } catch (e2) {>>"%Temp%\z.js"
echo                     ver1 = e2.description;>>"%Temp%\z.js"
echo                     sub = e2.description;>>"%Temp%\z.js"
echo                 }>>"%Temp%\z.js"
echo                 ver1 = trim(ver1);>>"%Temp%\z.js"
echo                 sub = trim(sub);>>"%Temp%\z.js"
echo                 csd1 = sub;>>"%Temp%\z.js"
echo             } else {>>"%Temp%\z.js"
echo                 wmi = GetObject("winmgmts:\\\\.\\root\\cimv2");>>"%Temp%\z.js"
echo                 wmiItems = wmi.execQuery(>>"%Temp%\z.js"
echo                     "Select Caption,CSDVersion,Version">>"%Temp%\z.js"
echo                     + " from Win32_OperatingSystem">>"%Temp%\z.js"
echo                 );>>"%Temp%\z.js"
echo                 wmie = new Enumerator(wmiItems);>>"%Temp%\z.js"
echo                 while (!wmie.atEnd()) {>>"%Temp%\z.js"
echo                     wmiItem = wmie.item();>>"%Temp%\z.js"
echo                     pn = wmiItem.Caption;>>"%Temp%\z.js"
echo                     csd1 = wmiItem.CSDVersion;>>"%Temp%\z.js"
echo                     ver1 = wmiItem.Version;>>"%Temp%\z.js"
echo                     wmie.moveNext();>>"%Temp%\z.js"
echo                 }>>"%Temp%\z.js"
echo                 pn = trim(pn);>>"%Temp%\z.js"
echo                 csd1 = trim(csd1);>>"%Temp%\z.js"
echo                 ver1 = trim(ver1);>>"%Temp%\z.js"
echo                 if (pn.indexOf("Windows 8.1") !== -1) {>>"%Temp%\z.js"
echo                     if (ver1 === "6.3.9600") {>>"%Temp%\z.js"
echo                         csd1 = "Update 1";>>"%Temp%\z.js"
echo                     }>>"%Temp%\z.js"
echo                 }>>"%Temp%\z.js"
echo             }>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         break;>>"%Temp%\z.js"
echo     case "2000!":>>"%Temp%\z.js"
echo         try {>>"%Temp%\z.js"
echo             ver1 = s.regRead(ver2);>>"%Temp%\z.js"
echo             sub = s.regRead(curver + "CSDVersion");>>"%Temp%\z.js"
echo         } catch (e3) {>>"%Temp%\z.js"
echo             ver1 = e3.description;>>"%Temp%\z.js"
echo             sub = e3.description;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         ver1 = trim(ver1);>>"%Temp%\z.js"
echo         sub = trim(sub);>>"%Temp%\z.js"
echo         csd1 = sub;>>"%Temp%\z.js"
echo         break;>>"%Temp%\z.js"
echo     case "NT!":>>"%Temp%\z.js"
echo         try {>>"%Temp%\z.js"
echo             ver1 = s.regRead(ver2);>>"%Temp%\z.js"
echo             sub = s.regRead(curver + "CSDVersion");>>"%Temp%\z.js"
echo         } catch (e6) {>>"%Temp%\z.js"
echo             ver1 = e6.description;>>"%Temp%\z.js"
echo             sub = e6.description;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         ver1 = trim(ver1);>>"%Temp%\z.js"
echo         sub = trim(sub);>>"%Temp%\z.js"
echo         csd1 = sub;>>"%Temp%\z.js"
echo         break;>>"%Temp%\z.js"
echo     case "95!":>>"%Temp%\z.js"
echo         try {>>"%Temp%\z.js"
echo             ver1 = s.regRead(curver + "VersionNumber");>>"%Temp%\z.js"
echo             sub = (s.regRead(curver + "SubVersionNumber")).toUpperCase();>>"%Temp%\z.js"
echo         } catch (e4) {>>"%Temp%\z.js"
echo             ver1 = e4.description;>>"%Temp%\z.js"
echo             sub = e4.description;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         ver1 = trim(ver1);>>"%Temp%\z.js"
echo         sub = trim(sub);>>"%Temp%\z.js"
echo         switch (ver1) {>>"%Temp%\z.js"
echo         case "4.00.950":>>"%Temp%\z.js"
echo             if (sub === "A") {>>"%Temp%\z.js"
echo                 csd1 = "Service Pack 1 / OEM Service Release 1";>>"%Temp%\z.js"
echo             }>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         case "4.00.1111":>>"%Temp%\z.js"
echo             csd1 = "OEM Service Release 2";>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         case "4.03.1216":>>"%Temp%\z.js"
echo         case "4.03.1214":>>"%Temp%\z.js"
echo         case "4.03.1212":>>"%Temp%\z.js"
echo             csd1 = (>>"%Temp%\z.js"
echo                 sub === "C">>"%Temp%\z.js"
echo                 ? "OEM Service Release 2.5">>"%Temp%\z.js"
echo                 : "USB Supplement to OSR2 / OEM Service Release 2.1">>"%Temp%\z.js"
echo             );>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         default:>>"%Temp%\z.js"
echo             csd1 = "";>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         break;>>"%Temp%\z.js"
echo     case "98!":>>"%Temp%\z.js"
echo         try {>>"%Temp%\z.js"
echo             ver1 = s.regRead(curver + "VersionNumber");>>"%Temp%\z.js"
echo             sub = (s.regRead(curver + "SubVersionNumber")).toUpperCase();>>"%Temp%\z.js"
echo         } catch (e5) {>>"%Temp%\z.js"
echo             ver1 = e5.description;>>"%Temp%\z.js"
echo             sub = e5.description;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         ver1 = trim(ver1);>>"%Temp%\z.js"
echo         sub = trim(sub);>>"%Temp%\z.js"
echo         switch (ver1) {>>"%Temp%\z.js"
echo         case "4.10.1998":>>"%Temp%\z.js"
echo             csd1 = "";>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         case "4.10.2222":>>"%Temp%\z.js"
echo             csd1 = "SE (Second Edition)";>>"%Temp%\z.js"
echo             break;>>"%Temp%\z.js"
echo         default:>>"%Temp%\z.js"
echo             csd1 = "";>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         break;>>"%Temp%\z.js"
echo     case "ME!":>>"%Temp%\z.js"
echo         csd1 = "Millennium Edition";>>"%Temp%\z.js"
echo         break;>>"%Temp%\z.js"
echo     default:>>"%Temp%\z.js"
echo         csd1 = "";>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo     if (!pn) {>>"%Temp%\z.js"
echo         pn = "(Unknown OS)";>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (!ver1) {>>"%Temp%\z.js"
echo         ver1 = "";>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (!csd1) {>>"%Temp%\z.js"
echo         csd1 = "";>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (!type1) {>>"%Temp%\z.js"
echo         type1 = "";>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (!bitwidth) {>>"%Temp%\z.js"
echo         bitwidth = "";>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (!target_dir) {>>"%Temp%\z.js"
echo         target_dir = "";>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return {>>"%Temp%\z.js"
echo         os: pn,>>"%Temp%\z.js"
echo         ver: ver1,>>"%Temp%\z.js"
echo         csd: csd1,>>"%Temp%\z.js"
echo         type: type1,>>"%Temp%\z.js"
echo         bit: bitwidth,>>"%Temp%\z.js"
echo         reg: "HKCR\\" + (>>"%Temp%\z.js"
echo             bitwidth === "64-bit">>"%Temp%\z.js"
echo             ? "WOW6432Node\\">>"%Temp%\z.js"
echo             : "">>"%Temp%\z.js"
echo         ) + "CLSID\\",>>"%Temp%\z.js"
echo         dir: target_dir>>"%Temp%\z.js"
echo     };>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function testRuntime (env, list) {>>"%Temp%\z.js"
echo     var fso = WScript.createObject("Scripting.FileSystemObject");>>"%Temp%\z.js"
echo     var s = WScript.createObject("WScript.Shell");>>"%Temp%\z.js"
echo     var file;>>"%Temp%\z.js"
echo     var name;>>"%Temp%\z.js"
echo     var data;>>"%Temp%\z.js"
echo     var has;>>"%Temp%\z.js"
echo     var target;>>"%Temp%\z.js"
echo     var o;>>"%Temp%\z.js"
echo     var p;>>"%Temp%\z.js"
echo     var q;>>"%Temp%\z.js"
echo     var i;>>"%Temp%\z.js"
echo     var l;>>"%Temp%\z.js"
echo     var ver;>>"%Temp%\z.js"
echo     var isLegacy;>>"%Temp%\z.js"
echo     var txt;>>"%Temp%\z.js"
echo     var open = false;>>"%Temp%\z.js"
echo     var doReg = false;>>"%Temp%\z.js"
echo     var msgs = [>>"%Temp%\z.js"
echo         "Operating System: " + env.os + (>>"%Temp%\z.js"
echo             env.csd>>"%Temp%\z.js"
echo             ? "\nOS CSD Version  : " + env.csd>>"%Temp%\z.js"
echo             : "">>"%Temp%\z.js"
echo         ) + "\nOS Bit Width    : " + env.bit>>"%Temp%\z.js"
echo         + "\nTarget Directory: " + env.dir>>"%Temp%\z.js"
echo         + "\n\n (filename) : [(version)] [(registry)]">>"%Temp%\z.js"
echo     ];>>"%Temp%\z.js"
echo     var VC2010A = "196BB40D-1578-3D01-B289-BEFC77A11A1E}\\";>>"%Temp%\z.js"
echo     var VC2010B = "F0C3E5D1-1ADE-321E-8167-68EF0DE699A5}\\";>>"%Temp%\z.js"
echo     var SEVENZIP = "";>>"%Temp%\z.js"
echo     var SEVENZIP2 = "Microsoft\\Windows\\CurrentVersion\\Uninstall\\7-Zip\\";>>"%Temp%\z.js"
echo     var SEVENZIP920 = "95!98!ME!NT!".indexOf(env.type) !== -1;>>"%Temp%\z.js"
echo     var froms = [];>>"%Temp%\z.js"
echo     var urls = [];>>"%Temp%\z.js"
echo     var uninst = "HKLM\\SOFTWARE\\" + (>>"%Temp%\z.js"
echo         env.bit === "64-bit">>"%Temp%\z.js"
echo         ? "WOW6432Node\\">>"%Temp%\z.js"
echo         : "">>"%Temp%\z.js"
echo     ) + "Microsoft\\Windows\\CurrentVersion\\Uninstall\\{";>>"%Temp%\z.js"
echo     for (name in list) {>>"%Temp%\z.js"
echo         file = env.dir + "\\" + name;>>"%Temp%\z.js"
echo         o = false;>>"%Temp%\z.js"
echo         p = false;>>"%Temp%\z.js"
echo         q = false;>>"%Temp%\z.js"
echo         ver = "";>>"%Temp%\z.js"
echo         txt = "";>>"%Temp%\z.js"
echo         isLegacy = false;>>"%Temp%\z.js"
echo         has = false;>>"%Temp%\z.js"
echo         if (fso.fileExists(file)) {>>"%Temp%\z.js"
echo             has = true;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         data = list[name];>>"%Temp%\z.js"
echo         for (p in data) {>>"%Temp%\z.js"
echo             switch (p) {>>"%Temp%\z.js"
echo             case "guid":>>"%Temp%\z.js"
echo                 if (has) {>>"%Temp%\z.js"
echo                     if (data.guid.length) {>>"%Temp%\z.js"
echo                         i = 0;>>"%Temp%\z.js"
echo                         l = data.guid.length;>>"%Temp%\z.js"
echo                         while (lt(i, l)) {>>"%Temp%\z.js"
echo                             q = reg_key_exists(>>"%Temp%\z.js"
echo                                 env.reg + "{" + data.guid[i] + "}\\">>"%Temp%\z.js"
echo                             );>>"%Temp%\z.js"
echo                             if (q) {>>"%Temp%\z.js"
echo                                 break;>>"%Temp%\z.js"
echo                             }>>"%Temp%\z.js"
echo                             i += 1;>>"%Temp%\z.js"
echo                         }>>"%Temp%\z.js"
echo                     } else if (name === "MSVCR100.DLL") {>>"%Temp%\z.js"
echo                         q = reg_key_exists(uninst + VC2010B);>>"%Temp%\z.js"
echo                         if (!q) {>>"%Temp%\z.js"
echo                             q = reg_key_exists(uninst + VC2010A);>>"%Temp%\z.js"
echo                         }>>"%Temp%\z.js"
echo                     }>>"%Temp%\z.js"
echo                 }>>"%Temp%\z.js"
echo                 break;>>"%Temp%\z.js"
echo             case "target":>>"%Temp%\z.js"
echo                 target = data.target;>>"%Temp%\z.js"
echo                 break;>>"%Temp%\z.js"
echo             default:>>"%Temp%\z.js"
echo                 if (p.indexOf(env.type) !== -1) {>>"%Temp%\z.js"
echo                     o = data[p];>>"%Temp%\z.js"
echo                 }>>"%Temp%\z.js"
echo             }>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo         if (o) {>>"%Temp%\z.js"
echo             txt = (name + "    ").slice(0, 12) + ": ";>>"%Temp%\z.js"
echo             if (!has) {>>"%Temp%\z.js"
echo                 txt += "NOT EXIST (" + target.join(", ") + " need" + (>>"%Temp%\z.js"
echo                     gt(target.length, 1)>>"%Temp%\z.js"
echo                     ? "">>"%Temp%\z.js"
echo                     : "s">>"%Temp%\z.js"
echo                 ) + " t" + "his)";>>"%Temp%\z.js"
echo                 open = true;>>"%Temp%\z.js"
echo                 froms[froms.length] = o.from;>>"%Temp%\z.js"
echo                 urls[urls.length] = o.url;>>"%Temp%\z.js"
echo             } else {>>"%Temp%\z.js"
echo                 ver = getVersion(file);>>"%Temp%\z.js"
echo                 if (ver) {>>"%Temp%\z.js"
echo                     if (isLaterVersion(ver, o.min_file_version)) {>>"%Temp%\z.js"
echo                         txt += "[v" + ver + "]";>>"%Temp%\z.js"
echo                         if (q) {>>"%Temp%\z.js"
echo                             txt += " OK.";>>"%Temp%\z.js"
echo                         } else if (name === "VB6JP.DLL") {>>"%Temp%\z.js"
echo                             txt += " OK.";>>"%Temp%\z.js"
echo                         } else {>>"%Temp%\z.js"
echo                             txt += " [Do Regsvr32]";>>"%Temp%\z.js"
echo                             doReg = true;>>"%Temp%\z.js"
echo                         }>>"%Temp%\z.js"
echo                     } else {>>"%Temp%\z.js"
echo                         txt += "[v" + ver + " (Do UPDATE)]";>>"%Temp%\z.js"
echo                         isLegacy = true;>>"%Temp%\z.js"
echo                         open = true;>>"%Temp%\z.js"
echo                         froms[froms.length] = o.from;>>"%Temp%\z.js"
echo                         urls[urls.length] = o.url;>>"%Temp%\z.js"
echo                         if (q) {>>"%Temp%\z.js"
echo                             txt += " [Do Regsvr32 /u]";>>"%Temp%\z.js"
echo                             doReg = true;>>"%Temp%\z.js"
echo                         } else if (name === "VB6JP.DLL") {>>"%Temp%\z.js"
echo                             txt += " [Overwrite with NEW VERSION]";>>"%Temp%\z.js"
echo                         }>>"%Temp%\z.js"
echo                     }>>"%Temp%\z.js"
echo                 } else {>>"%Temp%\z.js"
echo                     txt += "[(UNKNOWN VERSION)]";>>"%Temp%\z.js"
echo                     if (q) {>>"%Temp%\z.js"
echo                         txt += " OK. (?)";>>"%Temp%\z.js"
echo                     } else if (name === "VB6JP.DLL") {>>"%Temp%\z.js"
echo                         txt += " OK. (?)";>>"%Temp%\z.js"
echo                     } else {>>"%Temp%\z.js"
echo                         txt += " [Do Regsvr32] (?)";>>"%Temp%\z.js"
echo                         doReg = true;>>"%Temp%\z.js"
echo                     }>>"%Temp%\z.js"
echo                 }>>"%Temp%\z.js"
echo             }>>"%Temp%\z.js"
echo             msgs[msgs.length] = txt;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo     try {>>"%Temp%\z.js"
echo         SEVENZIP = s.regRead("HKLM\\SOFTWARE\\" + SEVENZIP2 + "DisplayName");>>"%Temp%\z.js"
echo     } catch (e7z) {>>"%Temp%\z.js"
echo         SEVENZIP = e7z.description;>>"%Temp%\z.js"
echo         try {>>"%Temp%\z.js"
echo             SEVENZIP = s.regRead(>>"%Temp%\z.js"
echo                 "HKLM\\SOFTWARE\\WOW6432Node\\" + SEVENZIP2 + "DisplayName">>"%Temp%\z.js"
echo             );>>"%Temp%\z.js"
echo         } catch (e7z2) {>>"%Temp%\z.js"
echo             SEVENZIP = e7z2.description;>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo     txt = "7-Zip       : ";>>"%Temp%\z.js"
echo     if (SEVENZIP.indexOf("HKLM\\SOFTWARE\\") !== -1) {>>"%Temp%\z.js"
echo         txt += "NOT INSTALLED // KB3096896 needs this";>>"%Temp%\z.js"
echo     } else {>>"%Temp%\z.js"
echo         SEVENZIP = trim(SEVENZIP);>>"%Temp%\z.js"
echo         SEVENZIP = SEVENZIP.split(" ")[1];>>"%Temp%\z.js"
echo         txt += "[v" + SEVENZIP + (>>"%Temp%\z.js"
echo             isLaterVersion(SEVENZIP, "4.51")>>"%Temp%\z.js"
echo             ? "] OK.">>"%Temp%\z.js"
echo             : " (Do UPDATE)]">>"%Temp%\z.js"
echo         );>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     msgs[msgs.length] = txt;>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo     if (froms.length) {>>"%Temp%\z.js"
echo         froms = removeArrayDuplicates(froms);>>"%Temp%\z.js"
echo         urls = removeArrayDuplicates(urls);>>"%Temp%\z.js"
echo         msgs[msgs.length] = "\nYou can get the following Runtimes:\n">>"%Temp%\z.js"
echo             + froms.join("\n");>>"%Temp%\z.js"
echo         WScript.echo(msgs.join("\n"));>>"%Temp%\z.js"
echo     } else {>>"%Temp%\z.js"
echo         if (!doReg) {>>"%Temp%\z.js"
echo             msgs[msgs.length] = "\nPERFECT!!";>>"%Temp%\z.js"
echo         }>>"%Temp%\z.js"
echo         WScript.echo(msgs.join("\n"));>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (open) {>>"%Temp%\z.js"
echo         s.run("explorer.exe " + env.dir, 1, true);>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo function isAble () {>>"%Temp%\z.js"
echo     var s = null;>>"%Temp%\z.js"
echo     try {>>"%Temp%\z.js"
echo         s = WScript.createObject("WScript.Shell");>>"%Temp%\z.js"
echo     } catch (e1) {>>"%Temp%\z.js"
echo         s = e1.description;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (typeof s === "string") {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo     try {>>"%Temp%\z.js"
echo         s = (>>"%Temp%\z.js"
echo             WScript.createObject("Scripting.FileSystemObject")>>"%Temp%\z.js"
echo         ).getFileVersion(WScript.ScriptFullName);>>"%Temp%\z.js"
echo     } catch (e2) {>>"%Temp%\z.js"
echo         s = e2.description;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     if (s.length) {>>"%Temp%\z.js"
echo         return false;>>"%Temp%\z.js"
echo     }>>"%Temp%\z.js"
echo     return true;>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"
echo if (isAble()) {>>"%Temp%\z.js"
echo     testRuntime(getEnvironments(), specs);>>"%Temp%\z.js"
echo     WScript.quit(0);>>"%Temp%\z.js"
echo } else {>>"%Temp%\z.js"
echo     WScript.quit(1);>>"%Temp%\z.js"
echo }>>"%Temp%\z.js"
echo.>>"%Temp%\z.js"

    cscript "%Temp%\z.js" //Nologo
    if not errorlevel 1 goto eof

    rem wsh js failed pattern?


    rem ----------------------------------------------------------------------




:win9xA

    ver|find "Windows 95">NUL
    if not errorlevel 1 goto win95

    ver|find "Windows 98">NUL
    if not errorlevel 1 goto win98

    ver|find "Windows Millennium">NUL
    if not errorlevel 1 goto winme

:win95
    echo Operating System: Windows 95
    goto win9xB

:win98
    echo Operating System: Windows 98
    goto win9xB

:winme
    echo Operating System: Windows ME
    goto win9xB


:win9xB
    "%windir%\..\"
    cd "%windir%\SYSTEM"

    echo Target Directory: %windir%\SYSTEM
    echo.
    if exist MSVBVM60.DLL echo MSVBVM60.DLL: EXIST
    if not exist MSVBVM60.DLL echo MSVBVM60.DLL: NOT EXIST // BMSE, uBMplay need this
    if exist COMDLG32.OCX echo COMDLG32.OCX: EXIST
    if not exist COMDLG32.OCX echo COMDLG32.OCX: NOT EXIST // BMSE, uBMplay need this
    if exist MSCOMCTL.OCX echo MSCOMCTL.OCX: EXIST
    if not exist MSCOMCTL.OCX echo MSCOMCTL.OCX: NOT EXIST // BMSE needs this
    if exist DX7VB.DLL echo DX7VB.DLL   : EXIST
    if not exist DX7VB.DLL echo DX7VB.DLL   : NOT EXIST // uBMplay, nazobmplay need this
    if exist DX8VB.DLL echo DX8VB.DLL   : EXIST
    if not exist DX8VB.DLL echo DX8VB.DLL   : NOT EXIST // nazobmplay needs this
    if exist VB6JP.DLL echo VB6JP.DLL   : EXIST
    if not exist VB6JP.DLL echo VB6JP.DLL   : NOT EXIST // nazobmplay, nBMplay, WAview need this
    start explorer "%windir%\SYSTEM"
    echo.
    goto eof










rem --------------------------------------------------------------------------

:winnt2x
    if not exist "%windir%\system32\WSHOM.OCX" goto winnt2xA

    cscript|find "Version">NUL
    if not errorlevel 1 goto winnt2xC
    goto winnt2xA

:winnt2xC
    cscript|find "Version 5.0">NUL
    if not errorlevel 1 goto winnt2xA
    goto js


:winnt2xA

    ver|find "NT">NUL
    if not errorlevel 1 goto winnt

    ver|find "2000">NUL
    if not errorlevel 1 goto win2000

    ver|find "XP">NUL
    if not errorlevel 1 goto winxphom


:winnt
    echo Operating System: Windows NT
    goto nt2k

:win2000
    echo Operating System: Windows 2000
    goto nt2k

:winxphom
    echo Operating System: Windows XP Home Edition
    goto nt2kxp


:nt2k
    cd /d "%windir%\system32"

    echo Target Directory: %windir%\system32
    echo.
    if exist MSVBVM60.DLL (
        echo MSVBVM60.DLL: EXIST
    ) else (
        echo MSVBVM60.DLL: NOT EXIST // BMSE, uBMplay need this
    )
    if exist COMDLG32.OCX (
        echo COMDLG32.OCX: EXIST
    ) else (
        echo COMDLG32.OCX: NOT EXIST // BMSE, uBMplay need this
    )
    if exist MSCOMCTL.OCX (
        echo MSCOMCTL.OCX: EXIST
    ) else (
        echo MSCOMCTL.OCX: NOT EXIST // BMSE needs this
    )
    ver|find "2000">NUL
    if not errorlevel 1 (
        if exist DX7VB.DLL (
            echo DX7VB.DLL   : EXIST
        ) else (
            echo DX7VB.DLL   : NOT EXIST // uBMplay, nazobmplay need this
        )
        if exist DX8VB.DLL (
            echo DX8VB.DLL   : EXIST
        ) else (
            echo DX8VB.DLL   : NOT EXIST // nazobmplay needs this
        )
    )
    if exist VB6JP.DLL (
        echo VB6JP.DLL   : EXIST
    ) else (
        echo VB6JP.DLL   : NOT EXIST // nazobmplay, nBMplay, WAview need this
    )
    start explorer "%windir%\system32"
    echo.
    endlocal
    goto eof

:nt2kxp
    cd /d "%windir%\System32"

    echo Target Directory: %windir%\System32
    echo.
    if exist MSVBVM60.DLL (
        echo MSVBVM60.DLL: EXIST
    ) else (
        echo MSVBVM60.DLL: NOT EXIST // BMSE, uBMplay need this
    )
    if exist COMDLG32.OCX (
        echo COMDLG32.OCX: EXIST
    ) else (
        echo COMDLG32.OCX: NOT EXIST // BMSE, uBMplay need this
    )
    if exist MSCOMCTL.OCX (
        echo MSCOMCTL.OCX: EXIST
    ) else (
        echo MSCOMCTL.OCX: NOT EXIST // BMSE needs this
    )
    if exist DX7VB.DLL (
        echo DX7VB.DLL   : EXIST
    ) else (
        echo DX7VB.DLL   : NOT EXIST // uBMplay, nazobmplay need this
    )
    if exist DX8VB.DLL (
        echo DX8VB.DLL   : EXIST
    ) else (
        echo DX8VB.DLL   : NOT EXIST // nazobmplay needs this
    )
    if exist MSVCR100.DLL (
        echo MSVCR100.DLL: EXIST
    ) else (
        echo MSVCR100.DLL: NOT EXIST // uBMplay 1.5.x needs this
    )
    if exist VB6JP.DLL (
        echo VB6JP.DLL   : EXIST
    ) else (
        echo VB6JP.DLL   : NOT EXIST // nazobmplay, nBMplay, WAview need this
    )
    start explorer "%windir%\System32"
    echo.
    endlocal
    goto eof



rem --------------------------------------------------------------------------




:winxpx
    if not exist "%windir%\system32\tasklist.exe" goto winnt2x

    cscript|find "Version">NUL
    if not errorlevel 1 goto js


:winxp
:win2003
    setlocal enableextensions
    for /f "tokens=2 delims=," %%i in (
        '%SystemRoot%\System32\wbem\wmic.exe os get Caption /format:CSV'
    ) do (
        set OSVERS="%%i"
    )
    for /f "tokens=2 delims=," %%i in (
        '%SystemRoot%\System32\wbem\wmic.exe os get CSDVersion /format:CSV'
    ) do (
        set OSSUBS="%%i"
    )
    set OSSYST=%SystemRoot%\SysWOW64
    if "%PROCESSOR_ARCHITECTURE%" equ "x86" (
        if "%PROCESSOR_ARCHITEW6432%" equ "AMD64" (
            set OSBITS=64-bit
        ) else if "%PROCESSOR_ARCHITEW6432%" equ "IA64" (
            set OSBITS=64-bit
        ) else if "%PROCESSOR_ARCHITEW6432%" equ "ARM64" (
            set OSBITS=64-bit
        ) else if "%PROCESSOR_ARCHITEW6432%" equ "EM64T" (
            set OSBITS=64-bit
        ) else (
            set OSBITS=32-bit
            set OSSYST=%SystemRoot%\System32
        )
    ) else (
        set OSBITS=64-bit
    )
    echo Operating System: %OSVERS:~1,-1%
    echo OS CSD Version  : %OSSUBS:~1,-1%
    echo OS Bit Width    : %OSBITS%
    echo Target Directory: %OSSYST%


rem --------------------------------------------------------------------------

:winvista
:win7
:win8
:win81
:win10
    echo.
    cd /d "%OSSYST%"
    if exist MSVBVM60.DLL (
        echo MSVBVM60.DLL: EXIST
    ) else (
        echo MSVBVM60.DLL: NOT EXIST // BMSE, uBMplay need this
    )
    if exist COMDLG32.OCX (
        echo COMDLG32.OCX: EXIST
    ) else (
        echo COMDLG32.OCX: NOT EXIST // BMSE, uBMplay need this
    )
    if exist MSCOMCTL.OCX (
        echo MSCOMCTL.OCX: EXIST
    ) else (
        echo MSCOMCTL.OCX: NOT EXIST // BMSE needs this
    )
    if exist DX7VB.DLL (
        echo DX7VB.DLL   : EXIST
    ) else (
        echo DX7VB.DLL   : NOT EXIST // uBMplay, nazobmplay need this
    )
    if exist DX8VB.DLL (
        echo DX8VB.DLL   : EXIST
    ) else (
        echo DX8VB.DLL   : NOT EXIST // nazobmplay needs this
    )
    if exist MSVCR100.DLL (
        echo MSVCR100.DLL: EXIST
    ) else (
        echo MSVCR100.DLL: NOT EXIST // uBMplay 1.5.x needs this
    )
    if exist VB6JP.DLL (
        echo VB6JP.DLL   : EXIST
    ) else (
        echo VB6JP.DLL   : NOT EXIST // nazobmplay, nBMplay, WAview need this
    )
    start explorer "%OSSYST%"
    echo.
    endlocal
    goto eof

:warn
    echo Operating System: Unknown Windows version


:eof
    if exist "%Temp%\z.js" del "%Temp%\z.js"
    pause

